﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication44
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.ultraDataSource1.Reset();
            var rootBand = this.ultraDataSource1.Band;
            rootBand.Columns.Add("Column 0");
            var childBand = this.ultraDataSource1.Band.ChildBands.Add("Child Band");
            childBand.Columns.Add("Column 0");
            var grandChildBand = childBand.ChildBands.Add("Grandchild Band");
            grandChildBand.Columns.Add("Column 0");

            for (int i = 0; i < 3; i++)
            {
                string value = string.Format("Parent Row {0}", i);
                var parentRow = this.ultraDataSource1.Rows.Add(new object[] { value });
                for (int j = 0; j < 3; j++)
                {
                    value = string.Format("Child Row {0},{1}", i, j);
                    var childRow = parentRow.GetChildRows(0).Add(new object[] { value });

                    for (int k = 0; k < 3; k++)
                    {
                        value = string.Format("Grandchild Row {0},{1},{2}", i, j, k);
                        childRow.GetChildRows(0).Add(new object[] { value });
                    }
                }                    
            }

            this.ultraGrid1.DataSource = this.ultraDataSource1;

            this.ultraGrid1.Rows.ExpandAll(true);
            this.ultraGrid1.DisplayLayout.PerformAutoResizeColumns(false, PerformAutoSizeType.AllRowsInBand, AutoResizeColumnWidthOptions.All);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;

            layout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.Horizontal;
        }
    }
}
